/*
 * server.hpp
 *
 *  Created on: 20 сент. 2022 г.
 *      Author: alexander
 */

#pragma once

#include <boost/asio.hpp>
#include <connection/connection.hpp>
#include <vector>
#include <optional>
#include <unordered_set>

namespace azh
{
    namespace io = boost::asio;

    enum class IPV
    {
        V4, V6
    };

    class TCPServer
    {
    public:
        TCPServer(IPV ipv, int port);

        int run();

        void broadcast(const std::string& message);
    private:
        IPV _ipVersion;
        int _port;

        io::io_context _ioContext;
        io::ip::tcp::acceptor _acceptor;
        std::optional<io::ip::tcp::socket> _socket;
        std::unordered_set<Connection::pointer> _connections;
    private:
        void startAccept();
    };

}
